/* --COPYRIGHT--,BSD
 * Copyright (c) 2017, Texas Instruments Incorporated
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * *  Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * *  Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * *  Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * --/COPYRIGHT--*/

#include "../main.h"
#include "ads112u04.h"
#include "tmp117.h"
#include "lmt01.h"

void cjc_init(void){
	int i;
	int j=0;
	for (i = 0; i < 8; i++) {
		if (config[config_id].cjc_options & (1 << i)) {
			switch((1<<i)){
				case RTD:
					rtd_raw = &cjc_raw[j++];
					break;
				case ADS112:
					temp_raw = &cjc_raw[j++];
					break;
				case TMP235:
					tmp235_raw = &cjc_raw[j++];
					break;
				case LMT70:
					lmt70_raw = &cjc_raw[j++];
					break;
				case TMP117:
					tmp117_raw = &cjc_raw[j++];
					tmp117_init();
					break;
				case LMT01:
					lmt01_raw = &cjc_raw[j++];
					lmt01_init();
					break;

			}
		}
	}
}

int cjc_get(int index){
    if(config[config_id].cjc_options & index){
        switch (index){
            case ADS112:
                return ads112_gettemp();
            case RTD:
                return ads112_getrtd();
            case LMT70:
            	return ads112_getlmt70();
            case TMP235:
				return ads112_gettmp235();
            case TMP117:
            	return tmp117_gettemp();
            case LMT01:
              	return lmt01_gettemp();
        }
    }
    return -1;
}



