/* --COPYRIGHT--,BSD
 * Copyright (c) 2017, Texas Instruments Incorporated
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * *  Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * *  Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * *  Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * --/COPYRIGHT--*/

#include <msp430.h>

//count in isr, check and reset timer, if timer count > x, then reset lmt counter and pass value over
volatile int lmt_value;
long *lmt01_raw;
void lmt01_init(void){
	P1IE |= (1<<0);
	P1REN |= 1;
	P1OUT |= 1;
	//TA0CCTL0 = CCIE;                          // CCR0 interrupt enabled
	TB0CCR0 = 0xffff;
	TB0CTL = TBSSEL_2 + MC_1 + TBCLR + ID_3;         // SMCLK, upmode, clear TAR, divide by 8
	__enable_interrupt();
}

int lmt01_gettemp(void){
	*lmt01_raw = lmt_value;
	return (lmt_value*25600.0)/4096.0 - 5000;
}

#pragma vector=PORT1_VECTOR
__interrupt void port1_isr(void){
	if(P1IFG & 1){
		P1IFG &= ~(1<<0);
		static int counter=0;
		if(TB0R > 5000){
			TB0CTL |= TBCLR;
			lmt_value = counter;
			counter = 0;
		}else{
			counter++;
			TB0CTL |= TBCLR;
		}
	}
}
