/* --COPYRIGHT--,BSD
 * Copyright (c) 2017, Texas Instruments Incorporated
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * *  Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * *  Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * *  Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * --/COPYRIGHT--*/

#ifndef MAIN_H_
#define MAIN_H_

enum cjc_options_enum {TMP117 = 1, LMT70 = 2, TMP235 = 4, RTD = 8, LMT01 = 0x10, ADS112 = 0x20};
enum adc_options_enum {ADS112U04 = 0, ADS7142 = 1, ADS8881 = 2};
enum tc_frontend_enum {OPV, INA, INT};

struct config_struct{
    const char *name;
    enum cjc_options_enum cjc_options;
    enum adc_options_enum adc_options;
    enum tc_frontend_enum tc_frontend;
    int cjc_no;
};

extern const struct config_struct config[6];
extern unsigned int config_id;
extern char adc_name[10];
extern char cjc_name[4][10];
extern long adc_raw;
extern long cjc_raw[4];
extern long adc_value;
extern int cjc_value[4];
extern int cjc_volt[4];
extern int cjc_temp[4];
extern int tc_temp;
extern int terminal_log;

#endif /* MAIN_H_ */
